package combinatorParsing2

/** An object encpsulating basic character constants */
object CharArrayReader {
  final val EofCh = '\032'
  final val CR = '\015'
}

/** A character array reader allows to read an array of character while maintaining
 *  position information 
 */
class CharArrayReader(source: Array[char], index: int, line: int, column: int) extends Reader[char] {
  import CharArrayReader._

  def this(source: Array[char]) = this(source, 0, 1, 1)

  private var i = index
  if (i + 1 < source.length && source(i) == CR && source(i + 1) == '\n') i = i + 1

  def first = if (i == source.length) EofCh else source(i) 

  def rest: CharArrayReader = {
    val ch = first
    if (ch == EofCh) this
    else if (ch == '\n') new CharArrayReader(source, i + 1, line + 1, 1)
    else new CharArrayReader(source, i + 1, line, column + 1)
  }

  def pos: Position = new CharArrayPosition(source, line, column)

  def atEnd = i == source.length
}
