package tapl6

import scala.io._
import tapl6._

trait TestSuite requires FJ.type {
  type Output
  def eval(in: String): Option[Output]

  def checkString(src: String) = {
    try {
      eval(src) match {
        case Some(t) => PrettyPrinter(t)
        case None => System.exit(1)
      }
    } catch {
      case e: Throwable =>
        e.printStackTrace
    }
    Console.println("-------------------------------\n")
  }

  def check(filename: String) = try {
    val buf = new compat.StringBuilder
    io.Source.fromFile(filename) foreach (line => buf.append(line))
    checkString(buf.toString)
    } catch {
      case e: java.io.FileNotFoundException =>
        Console.println(e.getMessage)
        exit(1)
    }

}
